import { IFormatterConstructor } from './types/formatters';
import { IConnectorConstructor } from './types/connector';
import { IParserConstructor } from './types/parser';
import { IHintConstructor } from './types/hints';
import { Severity } from '@hint/utils/dist/src/types/problems';
export * from './types/connector';
export * from './types/events';
export * from './types/formatters';
export * from '@hint/utils/dist/src/types/json-parser';
export * from './types/network';
export * from '@hint/utils/dist/src/types/problems';
export * from './types/hints';
export * from './types/parser';
export * from '@hint/utils/dist/src/schema-validation/schema-validation-result';
export * from './types/analyzer';
export * from './types/analyzer-error';
export declare type HintSeverity = Severity | keyof typeof Severity;
export declare type HintConfig = HintSeverity | [HintSeverity, any];
export declare type HintsConfigObject = {
    [key: string]: HintConfig | HintConfig[];
};
export declare type ConnectorOptionsConfig = {
    waitFor?: number;
    watch?: boolean;
};
export declare type ConnectorConfig = {
    name: string;
    options?: ConnectorOptionsConfig;
};
export declare type IgnoredUrl = {
    domain: string;
    hints: string[];
};
export declare type UserConfig = {
    connector?: ConnectorConfig | string;
    extends?: string[];
    parsers?: string[];
    hints?: HintsConfigObject | [HintSeverity, HintConfig][];
    browserslist?: string | string[];
    hintsTimeout?: number;
    formatters?: string[];
    ignoredUrls?: IgnoredUrl[];
};
export declare type Resource = IConnectorConstructor | IFormatterConstructor | IHintConstructor;
export declare type CLIOptions = {
    _: string[];
    'analytics-debug': boolean;
    config: string;
    debug: boolean;
    help: boolean;
    output: string;
    tracking: string;
    version: boolean;
    watch: boolean;
    formatters: string;
    hints: string;
};
export declare type HintResources = {
    connector: IConnectorConstructor | null;
    formatters: IFormatterConstructor[];
    incompatible: string[];
    missing: string[];
    parsers: IParserConstructor[];
    hints: IHintConstructor[];
};
export declare type StringKeyOf<T> = Extract<keyof T, string>;
//# sourceMappingURL=types.d.ts.map